Subject: Re: [PATCH] brcmfmac: prevent watchdog from interfering with scanning and connecting

From: "Fu, Zhonghui" <zhonghui.fu-VuQAYsv1563Yd54FQh9/[email-masked]>
Date: Tue, 05 Aug 2014 13:42:11 +0800

On 2014/8/5 4:12, Arend van Spriel wrote:
> On 08/04/14 18:52, Russell King - ARM Linux wrote:
>> On Tue, Aug 05, 2014 at 12:36:49AM +0800, Fu, Zhonghui wrote:
>>> Hi, Arend
>>>
>>> I investigated this issue, and its root cause is still that sdio
>>> controller can't receive interrupts from WiFi chip on sdio bus when
>>> sdio controller is in runtime suspend status. I am running 3.16-rc5
>>> linux kernel on ASUS T100TA tablet, and using sdhci-acpi driver.
>>
>> That's the root cause.  I fixed this with the Freescale i.MX SD driver
>> which is now able to report pending SDIO interrupts while runtime PM
>> suspended.
>>
>> Other host drivers probably need fixing too, or having runtime PM
>> disabled on them - if you can't receive SDIO interrupts while runtime
>> PM suspended, then entering runtime PM while you have a SDIO device
>> attached is a bug.
>>
>> This is something for the MMC people to deal with rather than Arend.
>
> Occasionally, the itch is there to fix mmc code, but this looks a bit tricky. The fun starts in sdio.c:mmc_attach_sdio():
>
>     /*
>      * Enable runtime PM only if supported by host+card+board
>      */
>     if (host->caps & MMC_CAP_POWER_OFF_CARD) {
>         /*
>          * Let runtime PM core know our card is active
>          */
>         err = pm_runtime_set_active(&card->dev);
>         if (err)
>             goto remove;
>
>         /*
>          * Enable runtime PM for this card
>          */
>         pm_runtime_enable(&card->dev);
>     }
>
> The comment above the if statement seems to be stating the right idea, but the code only looks at the host controller capability flags.

Yes, this code section is not implemented as its comments.

Thanks,
Zhonghui

>
> Regards,
> Arend
>
> -- 
> To unsubscribe from this list: send the line "unsubscribe linux-kernel" in
> the body of a message to [email-masked]
> More majordomo info at  http://vger.kernel.org/majordomo-info.html
> Please read the FAQ at  http://www.tux.org/lkml/

--
To unsubscribe from this list: send the line "unsubscribe linux-wireless" in
the body of a message to [email-masked]
More majordomo info at  http://vger.kernel.org/majordomo-info.html